 class Threads extends Thread {  //die Klasse Threads erbt alle Methoden und Attribute
                                //der Klasse Thread
 boolean running = false; //Attribut zur Kontrolle, ob Thread noch läuft
 int k;
 float[] X;
 float[] Y;
 float xx;
 float yy;
 int nummer;
 int[][][] AllMatrices;
 int[][][] MErgebnis;
  
public Threads(int tN){
   
    nummer = tN;
    X = new float[12];
    Y = new float[12];
    for(int i =0; i<12;i++){
      X[i] = 0; Y[i] = 0;
    }
   
    MErgebnis = new int[cols][rows][12];
    AllMatrices =new int[cols][rows][12];
    for (int k = 0; k<12; k++){
      for (int i = 0; i < cols; i++ ) {
          for (int j = 0; j < rows; j++ ) {
            AllMatrices[i][j][k] = 0;
          }
      }
   }
   for(int K = 0; K<12; K++){
    for (int i = 0; i < cols; i++ ) {
          for (int j = 0; j < rows; j++ ) {
            //M[i][j] = 0;
            MErgebnis[i][j][K] = 0;
          }
     }
   }
  }
  
//Rückgabe-Methode für Prozess-Nummer
  public int gibNummer(){   
     return nummer;   
   }
// Laufbefehl für den aktuellen Thread 
  public void run(){ 
    running = true;
   // println("Die interne Threadnummer ist: " 
   // + Thread.currentThread().getId() + ", Eigene Threadnummer: " + nummer);
    int K = nummer; 
    for (int i = 0; i < n; i++) {
        X[K]= random(-G,G);
        Y[K]= random(-G+0.5*K, -G+0.5*(K+1));
       
        cliffordStart(X[K], Y[K], K,bL);//letzter Wert: Blinddurchläufe (iter)
    }
    for (int i = 0; i < cols; i ++ ) {
       for (int j = 0; j < rows; j ++ ) {
         MErgebnis[i][j][K]= AllMatrices[i][j][K];
       }
    }
   
   println("Thread "+K + " ist beendet");
   
   running = false;
  }  
  
  void cliffordStart(double x0, double y0, int k, int BL) {
  double x = x0;
  double y = y0;
  int XX;
  int YY;
  int K = k;

//Startpunkt dazu
 if(startWerteZeigen){
    xx = (float)x;
    yy = (float)y;
    XX = round( map(xx, -G, G, 0, width));  if(XX>1599)XX=1599;
    YY = round( map(yy, -G, G, height, 0)); if(YY>1599)YY=1599;
    AllMatrices[XX][YY][K]++;  
 }
  for (int i = 0; i < BL; i++) {
    double xt = x;
    double yt = y;

    x = Math.sin(a*yt) + c*Math.cos(a*xt);
    y = Math.sin(b*xt) + d*Math.cos(b*yt);
  }
  xx =(float)x;
  yy =(float)y;
  XX = round( map(xx, minX, maxX, 0, width));  
  YY = round( map(yy, minY, maxY, height, 0)); 
  if(XX >=0 && XX<cols && YY>=0 && YY<rows) AllMatrices[XX][YY][K]++;  //nur der letze Term wird genommen
  
  //sonst außerhalb
  for (int i = BL+1; i < BL+m; i++) {
    double xt = x;
    double yt = y;
    XX=0; YY=0;
    x = Math.sin(a*yt) + c*Math.cos(a*xt);
    y = Math.sin(b*xt) + d*Math.cos(b*yt);
    xx =(float)x;yy=(float)y;
  
    XX = round( map(xx, minX, maxX, 0, width));  
    YY = round( map(yy, minY, maxY, height, 0)); 
    if(XX >=0 && XX<cols && YY>=0 && YY<rows) AllMatrices[XX][YY][K]++;  
  }
 }
}
